//stock2.cpp --  
#include <iostream>
#include "stock2.h"
//  
Stock::Stock() //   
{
std::strcpy(company, " ");
shares = 0;
share_val = 0.0;
total_val = 0.0;
}
Stock::Stock(const char * co, int n, double pr)
{
std::strncpy(company, co, 29);
company[29] = '\0';
if (n < 0)
{
std::cerr << "     ;  "
	<< company << "   0.\n";
shares = 0;
}
else
shares = n;
share_val = pr;
set_tot();
}
//  
Stock::~Stock() //   
{
}
//  
void Stock::buy(int num, double price)
{
if (num < 0)
{
std::cerr << "      . "
		<< " .\n";
}
else
{
shares += num;
share_val = price;
set_tot();
}
}
void Stock::sell(int num, double price)
{
using std::cerr;
if (num < 0)
{
cerr << "      . "
		 << " .\n";
}
else if (num > shares)
{
cerr << "     ,  ! "
		 << " .\n";
}
else
{
shares -= num;
share_val = price;
set_tot();
}
}
void Stock::update(double price)
{
share_val = price;
set_tot();
}
void Stock::show()
{
using std::cout;
using std::endl;
cout << ": " << company
		  << " : " << shares << endl
		  << "  : $" << share_val
		  << "  : $" << total_val << endl;
}
const Stock & Stock::topval(const Stock & s) const
{
if (s.total_val > total_val)
return s;
else
return *this;
}
