// twoswap.cpp --   
#include <iostream>
template <class Any>
void Swap(Any &a, Any &b);
struct job
{
  char name[40];
  double salary;
  int floor;
};
//  
template <> void Swap<job>(job &j1, job &j2);
void Show(job &j);
int main()
{
  using namespace std;
  cout.precision(2);
  cout.setf(ios::fixed, ios::floatfield);
  int i = 10, j = 20;
  cout << "i, j = " << i << ", " << j << ".\n";
  cout << "    int  swapper:\n";
  Swap(i,j); //   void Swap(int &, int &)
  cout << " i, j = " << i << ", " << j << ".\n";
  job sue = {" ", 73000.60, 7};
  job sidney = {" ", 78060.72, 9};
  cout << "     job:\n";
  Show(sue);
  Show(sidney);
  Swap(sue, sidney); //   void Swap(job &, job &)
  cout << "     job:\n";
  Show(sue);
  Show(sidney);
  return 0;
}
template <class Any>
void Swap(Any &a, Any &b) //  
{
  Any temp;
  temp = a;
  a = b;
  b = temp;
}
//      salary  floor  job
template <> void Swap<job>(job &j1, job &j2) // 
{
  double t1;
  int t2;
  t1 = j1.salary;
  j1.salary = j2.salary;
  j2.salary = t1;
  t2 = j1.floor;
  j1.floor = j2.floor;
  j2.floor = t2;
}
void Show(job &j)
{
  using namespace std;
  cout << j.name << ": $" << j.salary
        << "   " << j.floor << endl;
}
