// worker0.cpp --   
#include "worker0.h"
#include <iostream>
using std::cout;
using std::cin;
using std::endl;
//  Worker 
//    ,    
Worker::~Worker() {}
void Worker::Set()
{
	cout << "    : ";
	getline(cin, fullname);
	cout << "  : ";
	cin >> id;
	while (cin.get() != '\n')
		continue;
}
void Worker::Show() const
{
	cout << ": " << fullname << "\n";
	cout << ": " << id << "\n";
}
//  Waiter
void Waiter::Set()
{
	Worker::Set();
	cout << "   : ";
	cin >> panache;
	while (cin.get() != '\n')
		continue;
}
void Waiter::Show() const
{
	cout << ": \n";
	Worker::Show();
	cout << " : " << panache << "\n";
}
//  Singer
char * Singer::pv[] = {"other", "alto", "contralto",
"soprano", "bass", "baritone", "tenor"};
void Singer::Set()
{
	Worker::Set();
	cout << "   :\n";
	int i;
	for (i = 0; i < Vtypes; i++)
	{
		cout << i << ": " << pv[i] << " ";
		if ( i % 4 == 3)
			cout << endl;
	}
	if (i % 4 != 0)
		cout << endl;
	cin >> voice;
	while (cin.get() != '\n')
		continue;
}
void Singer::Show() const
{
	cout << ": \n";
	Worker::Show();
	cout << " : " << pv[voice] << endl;
}
