// random.cpp --     
#include <iostream> 	//     
#include <fstream>
#include <iomanip>
#include <cstdlib> 		// ( stdlib.h)  exit()
const int LIM = 20;
struct planet
{
	char name[LIM]; 		//  
	double population; 	// 
	double g; 				//   
};
const char * file = "planets.dat";	// ,   												// ( binary.cpp)
inline void eatline() { while (std::cin.get() != '\n') continue; }
int main()
{
	using namespace std;
planet pl;
cout << fixed;
//   
fstream finout; 		//    
finout.open(file,
ios_base::in | ios_base::out | ios_base::binary);
//:   Unix   | ios::binary
int ct = 0;
if (finout.is_open())
{
	finout.seekg(0); //   
		cout << "   "
		  << file << ":\n";
		while (finout.read((char *) &pl, sizeof pl))
		{
			cout << ct++ << ": " << setw(LIM) << pl.name << ": "
				  << setprecision(0) << setw(12) << pl.population
				  << setprecision(2) << setw(6) << pl.g << endl;
		}
		if (finout.eof())
			finout.clear(); //   eof
		else
		{
			cerr << "  " << file << ".\n";
			exit(EXIT_FAILURE);
		}
	}
	else
	{
		cerr << file << "      -- .\n";
		exit(EXIT_FAILURE);
	}
	//  
	cout << "  ,   : ";
	long rec;
	cin >> rec;
eatline(); //     
	if (rec < 0 || rec >= ct)
	{
		cerr << "   -- .\n";
exit(EXIT_FAILURE);
	}
	streampos place = rec * sizeof pl;	//    streampos
	finout.seekg(place); 					//  
	if (finout.fail())
	{
		cerr << "    \n";
		exit(EXIT_FAILURE);
	}
	finout.read((char *) &pl, sizeof pl);
	cout << " :\n";
	cout << rec << ": " << setw(LIM) << pl.name << ": "
		  << setprecision(0) << setw(12) << pl.population
		  << setprecision(2) << setw(6) << pl.g << endl;
	if (finout.eof())
		finout.clear(); //   eof
	cout << "  : ";
	cin.get(pl.name, LIM);
	eatline();
	cout << "  : ";
	cin >> pl.population;
	cout << "   : ";
	cin >> pl.g;
	finout.seekp(place); 	//  
	finout.write((char *) &pl, sizeof pl) << flush;
	if (finout.fail())
	{
		cerr << "   \n";
		exit(EXIT_FAILURE);
	}
	//   
	ct = 0;
	finout.seekg(0); 		//    
	cout << "   " << file
		  << ":\n";
	while (finout.read((char *) &pl, sizeof pl))
	{
		cout << ct++ << ": " << setw(LIM) << pl.name << ": "
			  << setprecision(0) << setw(12) << pl.population
			  << setprecision(2) << setw(6) << pl.g << endl;
	}
	finout.close();
	cout << ".\n";
	return 0;
}
