// memb_pt.cpp --     
#include <iostream>
using namespace std;
class Example
{
private:
int feet;
	int inches;
public:
	Example();
	Example(int ft);
	~Example();
	void show_in() const;
	void show_ft() const;
	void use_ptr() const;
};
Example::Example()
{
	feet = 0;
	inches = 0;
}
Example::Example(int ft)
{
	feet = ft;
	inches = 12 * feet;
}
Example::~Example()
{
}
void Example::show_in() const
{
	cout << inches << " \n";
}
void Example::show_ft() const
{
	cout << feet << " \n";
}
void Example::use_ptr() const
{
	Example yard(3);
	int Example::*pt;
	pt = &Example::inches;
	cout << " pt  &Example::inches:\n";
	cout << "this->pt: " << this->*pt << endl;
	cout << "yard.*pt: " << yard.*pt << endl;
	pt = &Example::feet;
	cout << " pt  &Example::feet:\n";
	cout << "this->pt: " << this->*pt << endl;
	cout << "yard.*pt: " << yard.*pt << endl;
	void (Example::*pf)() const;
	pf = &Example::show_in;
	cout << " pf  &Example::show_in:\n";
	cout << " (this->*pf)(): ";
	(this->*pf)();
	cout << " (yard.*pf)(): ";
	(yard.*pf)();
}
int main()
{
	Example car(15);
	Example van(20);
	Example garage;
	cout << " car.use_ptr():\n";
	car.use_ptr();
	cout << "\n van.use_ptr():\n";
	van.use_ptr();
	return 0;
}
